function Splitter_Ausblender()
{
	MY.ALPHA -= 4 * TIME;
	MY.VEL_Z -= 1.84 * TIME;
}

function EFKT_Splitter()
{
MY.VEL_X = Random(8) - 4;
MY.VEL_Y = Random(8) - 4;
MY.VEL_Z = Random(8) - 4;

MY.X += Random(32) - 16;
MY.Y += Random(32) - 16;
MY.Z += Random(32) - 16;

MY.MOVE = ON;
MY.SIZE = 4;
MY.BMAP = Flamme6;
MY.PASSABLE = ON;
MY.FLARE = ON;
MY.TRANSPARENT = ON;
MY.BRIGHT = ON;
MY.ALPHA = 32;
MY.LIFESPAN = 8;
MY.FUNCTION = Splitter_Ausblender;
}

function Schuss_Ausblender()
{ WAIT (1); MY.LIFESPAN = NULL; }

function EFKT_Schuss()
{
VEC_SUB (MY.X, MY.VEL_X);
MY.MOVE = ON;
MY.SIZE = 0.5;
MY.BMAP = Flamme3;
MY.PASSABLE = ON;
MY.FLARE = ON;
MY.TRANSPARENT = ON;
MY.BRIGHT = ON;
MY.BEAM = ON;
//MY.LIFESPAN = dplay_entrate;
MY.FUNCTION = Schuss_Ausblender;
}

function Feuer_Ausblender_Beam()
{
	MY.SIZE  -= TIME * 0.25;
	MY.ALPHA -= TIME * 0.5;
	MY.VEL_Z -= TIME * 1.84;
	IF (MY.SIZE <= 0) { MY.LIFESPAN = 0; }
}

function EFKT_Feuer_Init(speed)
{
var winkel;

winkel.PAN = Random(360);
winkel.TILT = Random(160) - 80;
VEC_TO_ANGLE (TEMP.PAN, MY.VEL_X);

ANG_ROTATE (TEMP.PAN, winkel.PAN);
MY.VEL_X = speed;
MY.VEL_Y = NULL;
MY.VEL_Z = NULL;

VEC_ROTATE (MY.VEL_X, TEMP.PAN);

	MY.MOVE = ON;
	MY.FLARE = ON;
	MY.BRIGHT = ON;
	MY.BEAM = ON;
	MY.ALPHA = 40 + Random(30);
	MY.FUNCTION = Feuer_Ausblender_Beam;
}

function EFKT_Feuer_gross_Rot()
{
	MY.SIZE = RANDOM(2)+6;
	MY.BMAP = Flamme3;
	EFKT_Feuer_Init(20);
}

function EFKT_Feuer_gross_Gelb()
{
	MY.SIZE = RANDOM(2)+1;
	MY.BMAP = Flamme4;
	EFKT_Feuer_Init(20);
}

function EFKT_Feuer_gross_Weiss()
{
	MY.SIZE = RANDOM(2)+1;
	MY.BMAP = Flamme6;
	EFKT_Feuer_Init(20);
}

function EFKT_Feuer_klein_Gelb()
{
	MY.SIZE = RANDOM(2)+1;
	MY.BMAP = Flamme4;
	EFKT_Feuer_Init(5);
}

function Rauch_Ausblender_Klein()
{ 
	MY.ALPHA -= 0.5 * TIME;
	MY.ALPHA = MAX(MY.ALPHA, 1);
	MY.SIZE += 0.8 * TIME;
	MY.VEL_Z = MY.ALPHA * 0.25;
}


function EFKT_Rauch_Klein()
{
	MY.X += Random(6)-3;
	MY.Y += Random(6)-3;
	MY.Z += Random(2)-1;

	MY.VEL_X = Random(2) - 1;
	MY.VEL_Y = Random(2) - 1;

	MY.MOVE = ON;
	MY.SIZE = 15 + Random(10);
	MY.BMAP = Rauch1;
	MY.BRIGHT = ON;
	MY.ALPHA = 10;
	MY.LIFESPAN = 20;
	MY.FUNCTION = Rauch_Ausblender_Klein;
}


function Trainsmoke_Ausblender()
{ 
	MY.ALPHA -= 0.25 * TIME;
	MY.ALPHA = MAX(MY.ALPHA, 1);
	MY.SIZE += 5 * TIME;
	MY.VEL_Z = MY.ALPHA * 0.2;
}


function EFKT_Trainsmoke()
{
	MY.X += Random(32)-16;
	MY.Y += Random(32)-16;
	MY.Z += Random(8)-4;

	MY.VEL_Y = -15;
	MY.VEL_X = Random(2)-1;

	MY.MOVE = ON;
	MY.SIZE = 75 + Random(20);
	MY.BMAP = Rauch1;
	MY.ALPHA = 32;
	MY.LIFESPAN = 128;
	MY.FUNCTION = Trainsmoke_Ausblender;
}


function Sandsturm_Ausblender()
{
	IF (MY.LIFESPAN > 48) {
		MY.ALPHA += 2 * TIME;
		MY.ALPHA = MIN(MY.ALPHA, 32);
	} ELSE {	IF (MY.LIFESPAN < 16) {
		MY.ALPHA -= 2 * TIME;
		MY.ALPHA = MAX(MY.ALPHA, 0);
	} }
}


function EFKT_Sandsturm()
{
	TEMP = Random(2048) - 1024;
	MY.X -= 1024 + TEMP;
	MY.Y -= 1024 - TEMP;
	MY.Z += Random(256)-64;

	MY.VEL_X = 45;
	MY.VEL_Y = 45;

	MY.MOVE = ON;
	MY.SIZE = 750 + Random(150);
	MY.BMAP = Rauch2;
//	MY.BRIGHT = ON;
	MY.ALPHA = 0;
	MY.LIFESPAN = 64;
	MY.FUNCTION = Sandsturm_Ausblender;
}


function Boom()
{
MY.FLARE = ON;
MY.TRANSPARENT = ON;
MY.UNLIT = ON;
MY.AMBIENT = 100;
MY.ALPHA = 55;
MY.BRIGHT = ON;
MY.FACING = ON;
MY.X += Random(48)-24;
MY.Y += Random(48)-24;
MY.Z += Random(20);
MY.ROLL = Random(360);
MY.PASSABLE = ON;
	MY.SCALE_X = 0.5 + Random(4)/20;
	MY.SCALE_Y = MY.SCALE_X;
	MY.SCALE_Z = MY.SCALE_X;

	WHILE (MY.ALPHA > 4) {
		MY.ALPHA -= 3.125 * TIME;
		MY.FRAME += TIME;
		MY.SCALE_X += 0.2 * TIME;
		MY.SCALE_Y = MY.SCALE_X;
		MY.SCALE_Z = MY.SCALE_X;
		MY.Z += 8 * TIME;
	WAIT (1);
	}
ENT_REMOVE(MY);
}

function Boomx()
{
MY.FLARE = ON;
MY.TRANSPARENT = ON;
MY.UNLIT = ON;
MY.AMBIENT = 100;
MY.ALPHA = 100;
MY.BRIGHT = ON;
MY.FACING = ON;
MY.X += Random(48)-24;
MY.Y += Random(48)-24;
MY.Z += Random(20)+128;
MY.ROLL = Random(360);
MY.PASSABLE = ON;
	MY.SCALE_X = 0.75 + Random(4)/20;
	MY.SCALE_Y = MY.SCALE_X;
	MY.SCALE_Z = MY.SCALE_X;

	WHILE (MY.FRAME < 17) {
//		MY.ALPHA -= 5.68 * TIME;
		MY.FRAME += TIME;
//		MY.SCALE_X += 0.2 * TIME;
		MY.SCALE_Y = MY.SCALE_X;
		MY.SCALE_Z = MY.SCALE_X;
		MY.Z -= TIME;
	WAIT (1);
	}
ENT_REMOVE(MY);
}